	list		p=16f84
	#include	<p16f84.inc>
	
	__CONFIG	_XT_OSC & _CP_OFF & _PWRTE_ON & _WDT_OFF
	
	Cblock	0x0C		; Deklaracije spremenljivk (konstant)
		Podatek : 2	; 16-biten podatek za izpis
		Stevec		; Stevec poslanih bitov
	ENDC
	
	; Definicije uporabnih konstant za prenos podatkov:
	
SER	EQU	0		; SER linija je na RA0
SCK	EQU	1		; SCK linija je na RA1
RCK	EQU	2		; RCK linija je na RA2

	org	0x000		; reset vektor
	goto	Glavni		; Pojdi na glavni program
	
	org	0x004

;************************ GLAVNI PROGRAM *********************************	

Glavni				; Glavni program
	bsf	STATUS,RP0	; Banka 1
	clrf	TRISA		; PORTA je izhodni port
	bcf	STATUS,RP0	; Banka 0
	clrf	PORTA		; Inicializiramo PORTA
	movlw	b'00000100'
	movwf	Podatek+1	; Vpisemo nizji bajt podatka
	movlw	b'01001000'
	movwf	Podatek		; Vpisemo visji bajt podatka
	call	Poslji		; Posljemo na izhodni pomikalni register
Konec	goto	Konec		; Neskoncna zanka

;**************** PODPROGRAM, KI POSLJE PODATEK NA 74HC595 ***************

Poslji
	movlw	.16
	movwf	Stevec		; Nalozimo stevilo bitov v Stevec
Delaj
	rrf	Podatek,f
	rrf	Podatek+1,f	; Pomaknemo podatek 16-bitno v desno
				; LSB bit -> Carry
	bcf	PORTA,SER	; Nastavimo podatek na 0
	btfsc	STATUS,C	; Ali je C=1?
	bsf	PORTA,SER	; Da, nastavi podatek na 1
	bsf	PORTA,SCK
	bcf	PORTA,SCK	; SCK impulz, poslji podatek
	decfsz	Stevec,f	; Ali smo poslali ze  vseh 16 bitov?
	goto	Delaj		; Ne se, nadaljuj
	bsf	PORTA,RCK	; Da, prenesi na izhod
	return			; Vrni se iz podprograma
	
	END
