	list		p=16f84		; Tip mikrokontrolerja
	#include	<p16f84.inc>	; Vkljucitev .inc datoteke
	
	__CONFIG	_WDT_OFF & _XT_OSC & _PWRTE_ON & _CP_OFF

	Cblock	0x0C			; Blok za definicijo konstant
		Deljenec : 2		; Deljenec (2 bajta)
		Deljitelj : 2		; Deljitelj (2 bajta)
		Kolicnik : 2		; Kolicnik (2 bajta)
		Ostanek: 2		; Ostanek (2 bajta)
		Stevec			; Stevec za deljenje
	endc				; Konec bloka konstant

	org	0x000
	goto	Glavni			; Reset vektor

	org	0x004
Glavni					; Glavni program
	movlw	0x4C
	movwf	Deljenec
	movlw	0x0A
	movwf	Deljenec+1
	movlw	0x12
	movwf	Deljitelj
	movlw	0x34
	movwf	Deljitelj+1		; Nalozi podatke v registre
					; Deljenec = 0x4C0A
					; Deljitelj = 0x1234

	call	Deli16			; Klici deljenje

	; Kolicnik sedaj vsebuje kolicnik, Ostanek pa ostanek deljenja
	; Kolicnik = 0x0004, Ostanek = 0x033A

Zanka	goto	Zanka			; Neskoncna zanka

;***** DELJENJE: Deljenec / Deljitelj = Kolicnik in Ostanek **************

Deli16
	clrf	Kolicnik
	clrf	Kolicnik+1		; Izbrisemo Kolicnik
	clrf	Ostanek
	clrf	Ostanek+1		; Izbrisemo ostanek
	movlw	.17
	movwf	Stevec			; 17 -> Stevec (stevilo ponovitev+1)
Delaj
	decf	Stevec,f		; Zmanjsamo Stevec
	btfsc	STATUS,Z		; Ali je stevec ze 0?
	return				; Da, koncaj deljenje
	rlf	Deljenec+1,f
	rlf	Deljenec,f		; Pomakni cel Deljenec v levo
	rlf	Ostanek+1,f
	rlf	Ostanek,f		; Pomakni cel Ostanek v levo s C
	call	Deli			; Klici pomozni podprogram za Kolicnik
	goto	Delaj			; Nadaljuj (16x)
	
;********************* POMOZNI PODPROGRAM ZA DELJENJE ********************

Deli
	movf	Deljitelj+1,w		; Nizji bajt deljitelja -> W
	subwf	Ostanek+1,f		; Odstej od nizjega bajta ostanka
	movf	Deljitelj,w		; Visji bajt deljitelja -> W
	btfss	STATUS,C		; Ali je prislo do prenosa (C=0)?
	incf	Deljitelj,w		; Da, povecaj deljitelj -> W
	subwf	Ostanek,f		; Odstej od visjega bajta ostanka
	btfss	STATUS,C		; Ali je rezultat negativen (C=0)?
	goto	Negativno		; Da, skoci na Negativno
	bsf	STATUS,C		; Ne, C=1
	rlf	Kolicnik+1,f
	rlf	Kolicnik,f		; Kolicnik pomakni v levo in LSB=C=1
	return				; Konec pomoznega podprograma
Negativno
	bcf	STATUS,C		; C=0
	rlf	Kolicnik+1,f
	rlf	Kolicnik,f		; Kolicnik pomakni v levo, LSB=C=0
	movf	Deljitelj+1,w
	addwf	Ostanek+1,f
	btfsc	STATUS,C
	incf	Ostanek,f
	movf	Deljitelj,w
	addwf	Ostanek,f		; 16 bitno sestej Kolicnik in Ostanek, da
					; dobis spet prvoten ostanek (pozitiven)
	return				; Konec pomoznega podprograma

	end
