	list		p=16f84
	#include	<p16f84.inc>

	__CONFIG	_WDT_OFF & _XT_OSC & _PWRTE_ON & _CP_OFF

	
Naslov	equ	0x0c		; Naslov podatka v EEPROM-u
Podatek equ	0x0d		; Podatek za vpis ali branje

	org	0x000
	goto	Glavni		; Pojdi v glavni program

	org	0x004

Glavni
	bcf	STATUS,RP0	; Banka 0
	movlw	0x00
	movwf	Naslov		; Nastavimo zeleni naslov
	call	Beri_EE		; Preberemo zeleni naslov v Podatek
	movlw	0x3E
	movwf	Naslov		; Izberemo nov naslov
	call	Pisi_EE		; Vpisemo podatek v EEPROM
	movlw	0x01
	movwf	Naslov		; Izberemo nov naslov
	call	Beri_EE		; Preberemo podatek -> Podatek
	movlw	0x3F		
	movwf	Naslov		; Izberemo nov naslov
	call	Pisi_EE		; Podatek -> nov naslov

Konec	goto	Konec		; Koncna zanka

;*************************************************************************

Beri_EE				; Podprogram za branje iz EEPROM-a
	bcf	STATUS,RP0	; Banka 0
	movf	Naslov,w
	movwf	EEADR		; Naslov podatka nalozimo v EEADR
	bsf	STATUS,RP0	; Banka 1
	movlw	B'00000001'	
	movwf	EECON1		; Sprozimo branje
	bcf	STATUS,RP0	; Banka 0
	movf	EEDATA,w
	movwf	Podatek		; EEDATA -> Podatek
	return

;*************************************************************************

Pisi_EE				; Podprogram za pisanje v EEPROM
	bcf	STATUS,RP0	; Banka 0
	movf	Podatek,w
	movwf	EEDATA		; Podatek -> EEDATA
	movf	Naslov,w
	movwf	EEADR		; Naslov -> EEADR
	bsf	STATUS,RP0	; Banka 1
	bsf	EECON1,WREN	; Omogocimo vpis v EEPROM
	bcf	INTCON,GIE	; Onemogocimo prekinitve (ce jih uporabljamo)

;*************************************************************************
;* SLEDECI DEL MORA BITI NATANCNO TAK, KOT SEM GA TU ZAPISAL!!!		 *
;*************************************************************************	
	movlw	0x55		
	movwf	EECON2		; Vpis prve kode v EECON2
	movlw	0xAA
	movwf	EECON2		; Vpis druge kode v EECON2
	bsf	EECON1,WR	; Pricnemo vpis podatka
	
;**************	     KONEC ZAPOREDJA	  ********************************
	
	bsf	INTCON,GIE	; Zopet omogocimo prekinitve (ce jih uporabljamo)
Cakaj	btfsc	EECON1,WR	
	goto	Cakaj		; Cakamo, da se vpis konca (WR bit mora postati 1)
	bcf	STATUS,RP0	; Banka 0
	return

	org	0x2100
	DE	0xBE, 0xDA	; V prvi dve lokaciji EEPROM-a vpisemo 2 stevili

	END
	
