	list		p=16F84
	#include	<p16f84.inc>

	__CONFIG	_WDT_OFF & _XT_OSC & _CP_OFF & _PWRTE_ON

;************************** DEKLARACIJE SPREMENLJIVK *********************

Temp1	equ	0x0C			
Temp2	equ	0x0D			; Zacasni spremenljivki

;*************************** DEFINICIJE NOVIH OZNAK **********************

	#define	RS	PORTB,1		; RS LCD linija
	#define	RW	PORTB,2		; RW LCD linija
	#define	E	PORTB,3		; E LCD linija

;**************************** ZACETEK PROGRAMA ***************************

	org	0x000
	goto	Glavni			; Reset vektor

	org	0x004
Glavni					; Glavni program, prekinitev ni
	bsf	STATUS,RP0		; Banka 1
	clrf	TRISA
	clrf	TRISB			; Vsi pini izhodni
	movlw	b'10000001'
	movwf	OPTION_REG		; Timer povecuje notranja ura, preddelilnik
					; 1:4 (prekoracenje TMR0 v 1,024ms)
	bcf	STATUS,RP0		; Banka 0
	clrf	PORTA
	clrf	PORTB			; Vse pine postavimo na 0
	clrf	INTCON			; Onemogocimo vse prekinitve, T0IF je 0

	call	LCD_Init		; Inicializiramo LCD

Konec	goto	Konec			; Neskoncna zanka

;*************************** PODPROGRAMI *********************************

;********************* IZPISE VREDNOST IZ W NA LCD ***********************

LCD_pisi
	movwf	Temp1			; Shranimo W (podatek) v Temp1
	movlw	0x0F			; 0x0F -> W
	andwf	PORTB,f			; Izbrisemo zgornje 4 bite PORTB
	movf	Temp1,w			; W povrnemo nazaj iz Temp1
	andlw	0xF0			; Izbrisemo spodnje 4 bite W (podatka)
	iorwf	PORTB,f			; Posljemo zgornje 4 bite podatka
	bsf	E
	bcf	E			; Obvestimo LCD o novem podatku
	swapf	Temp1,f			; Zamenjamo nibble v Temp1
	movlw	0xF0			; 0xF0 -> W
	andwf	Temp1,f			; Izbrisemo spodnje 4 bite Temp1
	movlw	0x0F			; 0x0F -> W
	andwf	PORTB,f			; Izbrisemo zgornje 4 bite PORTB
	movf	Temp1,w			; Temp1 -> W
	iorwf	PORTB,f			; Posljemo spodnje 4 bite podatka
	bsf	E			; Potrdimo podatek
	bcf	E			; Obvestimo LCD o novem podatku
	call	Cakaj119u		; Pocakamo 119us
	return				; Konec podprograma

;****************** NAREDI ZAKASNITEV 119us ******************************

Cakaj119u
	movlw	.38			; Stevilo ponovitev zanke -> W
	movwf	Temp2			; W -> Temp2
Se	decfsz	Temp2,f			; Zmanjsaj Temp2 za 1
	goto	Se			; Ce Temp2 se ni 0, nadaljuj zanko
	return				; Temp0=0, konec podprograma

;****************** ZAKASNITEV PRIBLIZNO 1,03ms x W **********************

CakajMs
	movwf	Temp2			; Shrani stevilo ponovitev W -> Temp2
	clrf	TMR0			; Pobrise TMR0 register
Cak1	btfss	INTCON,T0IF		; Ali je timer ze pristel do konca?
	goto	Cak1			; Ne, preverjaj naprej
	bcf	INTCON,T0IF		; Da, izbrisi T0IF
	decfsz	Temp2,f			; Zmanjsaj stevec ponovitev
	goto	Cak1			; Stevec se ni 0, nadaljuj zanko
	return				; Stevec je 0, konec podprograma

;********************* INICIALIZIRA LCD **********************************

LCD_Init
	bcf	RW
	bcf	RS			; R/W in RS liniji na 0
	movlw	.15			; Parameter od CakajMs -> W
	call	CakajMs			; priblizno 15ms pavze za LCD
	movlw	0x30
	movwf	PORTB			; Na D7 - D4 posljemo 0x3
	bsf	E
	bcf	E			; Opozorimo LCD na nov podatek	
	movlw	.5
	call	CakajMs			; Priblizno 5ms pavze
	movlw	0x30
	movwf	PORTB			; Na D7 - D4 posljemo 0x3
	bsf	E
	bcf	E			; Opozorimo LCD na nov podatek
	call	Cakaj119u		; 119us pavze
	movlw	0x30
	movwf	PORTB			; Na D7 - D4 posljemo 0x3
	bsf	E
	bcf	E			; Opozorimo LCD na nov podatek
	movlw	.5
	call	CakajMs			; Priblizno 5ms pavze
	movlw	0x20
	movwf	PORTB			; Na D7 - D4 posljemo 0x2
	bsf	E
	bcf	E			; Opozorimo LCD na nov podatek
	call 	Cakaj119u		; 119us pavze
					; Sedaj smo v 4-bitnem nacinu
	movlw	0x28
	call	LCD_pisi		; Posljemo 0x28 na LCD
	movlw	0x08
	call	LCD_pisi		; Posljemo 0x08 na LCD
	movlw	0x01
	call	LCD_pisi		; Posljemo 0x01
	movlw	.2
	call	CakajMs			; Zahtevana zakasnitev >2ms
	movlw	0x06
	call	LCD_pisi		; Posljemo 0x06 na LCD
	movlw	0x0F
	call	LCD_pisi		; Posljemo 0x0F na LCD
	return				; Konec podprograma

	END

