	list		p=16f84
	#include	<p16f84.inc>
	
	__CONFIG	_CP_OFF & _XT_OSC & _WDT_OFF & _PWRTE_ON
	
	Cblock	0x0C			; Deklaracija spremenljivk (konstant)
		Stevec			; Stevec za izpis na zaslon
		Enice, Desetice		; Enice in desetice za izpis na zaslon
		Mux			; Spremenljivka za multipleks
		W_reg, Stat_reg		; Zacasne spremenljivke za pomembne registre
		Cas			; Spremenljivka za stetje casa
		Nicla			; Indikator nicle
		Zacasna			; Zacasna spremenjlivka za Stevec
	ENDC
	
	org	0x000			; Reset vektor
	goto	Glavni			; Skok na glavni program
	
	org	0x004			; Prekinitveni vektor
	
;********************* PREKINITVENI PODPROGRAM ***************************

PrekPod					; Prekinitveni podprogram
	bcf	INTCON,GIE		; Onemogocimo prekinitve
	movwf	W_reg			; Shranimo register W
	swapf	STATUS,w		
	movwf	Stat_reg		; Shranimo register STATUS
	clrf	TMR0			; Resetiramo Timer 0
	movlw	b'11111100'
	andwf	PORTA,f			; Izklopimo vse cifre
	btfsc	Mux,0			; Ali je na vrsti prva cifra?
	goto	Druga			; Ne, pojdi na Druga
	movf	Enice,w			; Da
	call	Znaki
	movwf	PORTB			; Poisci ustrezno kodo znaka in jo poslji
	bsf	PORTA,0			; Vklopi prvo cifro
	goto	Zakljuci
Druga
	movf	Desetice,w		; Desetice -> W
	call	Znaki			; Poglej kodo cifre
	movwf	PORTB			; Poslji kodo cifre na LED
	bsf	PORTA,1			; Vklopi drugo cifro
Zakljuci
	movlw	.1
	xorwf	Mux,f			; Preklopi na drugo cifro
	bcf	INTCON,T0IF		; Izklopi T0IF
	swapf	Stat_reg,w
	movwf	STATUS			; Povrni STATUS
	movf	W_reg,w			; Povrni W
	incf	Cas,f			; Povecamo spremenljivko za merjenje casa
	bsf	INTCON,GIE		; Vklopimo GIE
	retfie				; Konec prekinitvenega podprograma

;************************* GLAVNI PROGRAM ********************************
	
Glavni					; Glavni program
	bsf	STATUS,RP0		; Banka 1
	movlw	b'10000011'
	movwf	OPTION_REG		; Nastavimo TMR0, 1:16 preddelilnik
	clrf	TRISA			; PORTA je izhod za multipleks
	clrf	TRISB			; PORTB je izhod na LED prik.
	bcf	STATUS,RP0		; Banka 0
	movlw	.1
	movwf	Mux			; Inicializiramo Mux na prvo cifro
	clrf	PORTB			; Izklopimo prikazovalnik
	movlw	b'10100000'
	movwf	INTCON			; Vklopimo timer 0 prekinitev
	clrf	Stevec			; Zacetna vrednost na LED prik.
Delaj
	movf	Stevec,w		; Stevec -> W
	movwf	Zacasna			; Stevec -> Zacasna
	call	Pisi			; Izpisemo Stevec na LED prik.
	call	Cakaj05			; Naredimo zakasnitev ~0,5s
	incf	Stevec,f		; Povecamo Stevec za 1
	movlw	.100
	subwf	Stevec,w
	btfsc	STATUS,Z		; Ali smo ze pristeli do 100?
	clrf	Stevec			; Da, postavi Stevec spet na 0
	goto	Delaj			; Od zacetka
	
;******************** TABELA ZNAKOV NA LED PRIKAZOVALNIKU ****************

Znaki	addwf	PCL,f			; Izracunaj odmik
	DT	0xB7, 0x82, 0xE5, 0xE3, 0xD2, 0x73, 0x77, 0xA2, 0xF7, 0xF3, 0x00
		; Definicije znakov za izpis na LED prikazovalnik
		
;******************* ZAKASNITEV ~0,5s ************************************

Cakaj05
	clrf	Cas			; Inicializiramo Cas
Ne_se
	movlw	.122
	subwf	Cas,w			; 122 * 4,1ms = ~500ms
	btfss	STATUS,Z		; Je ze poteklo 0,5s?
	goto	Ne_se			; Ne se, pojdi na Ne_se
	return				; Da, koncaj zakasnitev

;*************** IZPISE 2-MESTNO DESETISKO STEVILO ***********************

Pisi	
	bsf	Nicla,0			; Vklopimo indikator nicle
	clrf	Desetice		; Desetice=0
Nadaljuj
	movlw	.10
	subwf	Zacasna,f		; Od Zacasna odstejemo 10
	btfsc	STATUS,C		; Ali smo dobili negativen rezultat?
	goto	Ena_vec			; Ne, pristej 1 k deseticam
	addwf	Zacasna,f		; Da, naredi ga zopet pozitivnega
	goto	Konec			; Koncaj
Ena_vec
	bcf	Nicla,0			; Pobrisi indikator nicle
	incf	Desetice,f		; Povecaj Desetice
	goto	Nadaljuj		; Nadaljuj pretvorbo
Konec
	movf	Zacasna,w		; Zacasna -> W
	movwf	Enice			; Zacasna -> Enice
	movlw	.10
	btfsc	Nicla,0			; Ali je potrebno izpisati niclo?
	movwf	Desetice		; Ne, shrani v Desetice 10 (izklop zaslona)
	return				; Konec podprograma

	END				; Konec programa
