	list		p=16f84
	#include	<p16f84.inc>
	
	__CONFIG	_CP_OFF & _XT_OSC & _WDT_OFF & _PWRTE_ON
	
	Cblock	0x0C			; Deklaracija spremenljivk (konstant)
		Stevilo			; Stevilo za izpis
		Stevec			; Stevec za zakasnitev
	ENDC
	
	org	0x000			; Reset vektor
	goto	Glavni			; Skok na glavni program
	
	org	0x004			; Prekinitveni vektor
	
Glavni					; Glavni program
	bsf	STATUS,RP0		; Banka 1
	movlw	b'10000011'
	movwf	OPTION_REG		; Nastavimo TMR0, 1:16 preddelilnik
	movlw	0xFF
	movwf	TRISB			; PORTB bo izhod na LED prikazovalnik
	bcf	STATUS,RP0		; Banka 0
	clrf	PORTB			; Izklopimo zaslon
	clrf	INTCON			; Brez prekinitev
	clrf	Stevilo			; Stevilo=0
Delaj
	call	Izpisi			; Izpisemo Stevec na LED prik.
	call	Pocakaj			; Naredimo zakasnitev ~0,5s
	incf	Stevilo,f		; Povecamo Stevilo za 1
	btfsc	Stevilo,4		; Ali smo ze pristeli do 16?
	clrf	Stevilo			; Da, postavi Stevilo spet na 0
	goto	Delaj			; Od zacetka
	
; ******************* PODPROGRAM ZA ZAKASNITEV ~0,5s ********************

Pocakaj
	clrf	Stevec			; Pobrisemo Stevec
	clrf	TMR0			; Pobrisemo TMR0
Cakaj
	btfss	INTCON,T0IF		; Ali je ze preteklo ~4,1ms?		
	goto	Cakaj			; Ne se
	clrf	INTCON			; Pobrisi T0IF
	incf	Stevec,f		; Povecaj Stevec
	movlw	.122
	subwf	Stevec,w
	btfss	STATUS,Z		; Ali je ze minilo ~ 122*4,1=500ms?
	goto	Cakaj			; Ne se, cakaj naprej
	return				; Da, pojdi iz podprograma
	
;******************** TABELA ZNAKOV NA LED PRIKAZOVALNIKU ****************

Znaki	addwf	PCL,f			; Izracunaj odmik
	DT	0xB7, 0x82, 0xE5, 0xE3, 0xD2, 0x73, 0x77, 0xA2, 0xF7, 0xF3
	DT	0xF6, 0x57, 0x35, 0xC7, 0x75, 0x74	; Znaki

;********** PODPORGRAM ZA IZPIS ZNAKA NA LED PRIK. (znak v Stevilo) ******
	
Izpisi
	movf	Stevilo,w		; Stevilo -> W
	call	Znaki			; Pogledaj kodo znaka
	movwf	PORTB			; Izpisi na LED prik.
	return				; Konec podprograma
	
	END				; Konec programa
