        list            p=16f84         ; Tip mikrokontrolerja
        #include        <p16f84.inc>    ; Glava za mikrokontroler
        
        __CONFIG	_CP_OFF & _WDT_OFF & _XT_OSC & _PWRTE_ON
       
     	Cblock  0x0C                    ; Definicije spremenljivk
                Tipka			; Koda pritisnjene tipke
                Stevec1, Stevec2	; Stevca za zakasnitev
                Zacasna			; Zacasna spremenljivka za debounce
        ENDC
        
Tipka5	EQU	b'00100100'		; Koda tipke 5 na tipkovnici

        org     0x000
        goto    Glavni                  ; Reset vektor
        
        org	0x004
Glavni
	bsf	STATUS,RP0		; Banka 1
	movlw	0xF0
	movwf	TRISB			; 0xF0 -> TRISB (RB4 - RB7 vhodi)
	bcf	STATUS,RP0		; Banka 0
	clrf	INTCON			; Onemogocimo prekinitve
	clrf	PORTB			; Inicializiramo PORTB
Kar_delaj	
	call	Cakaj			; Zakasnitev za debounce
	call 	Beri_matriko		; Prvic preberemo tipko
	movf	Tipka,w
	movwf	Zacasna			; Shranimo Tipka -> Zacasna
	call	Cakaj			; Zakasnitev za debounce
	call	Beri_matriko		; Drugic preberemo tipko
	movf	Tipka,w			; Nova vrednost Tipka -> W
	subwf	Zacasna,w		; Primerjamo Tipka in Zacasna
	btfss	STATUS,Z		; Ali sta vrednosti enaki?
	goto	Kar_delaj		; Nista, nadaljuj preverjanje
	movlw	0xF0
	andwf	Tipka,w			; Izbrisemo spodnje 4 bite od Tipka
	btfsc	STATUS,Z		; Ali je bila sploh pritisnjena tipka?
	goto	Kar_delaj		; Ne, beri naprej
	movlw	Tipka5
	subwf	Tipka,w			; Primerjamo Tipka s kodo tipke 5
	bcf	PORTB,0			; Izklopimo LED na RB0
	btfsc	STATUS,Z		; Ali je bila pritisnjena tipka 5?
	bsf	PORTB,0			; Da, vklopi LED na RB0
	goto	Kar_delaj		; Nadaljuj neskoncno zanko
	
;*************** PODPROGRAM ZA BRANJE MATRICNE TIPKOVNICE 3x4 ************

Beri_matriko				; Podprogram za branje matricne tipkovnice
	movlw	b'00000001'
	movwf	Tipka			; Zacnemo s 1. stolpcem
Znova
	bcf	STATUS,C		; C=0
	rlf	Tipka,f			; Pomaknemo na naslednji stolpec
	movlw	b'11110001'		; AND maska
	andwf	PORTB,f			; Izbrisemo bite stolpcev na PORTB
	movf	Tipka,w			; Tipka -> W
	iorwf	PORTB,f			; Vklopimo  ustrezni stolpec
	btfsc	Tipka,4			; Ali smo obdelali vse stolpce?
	return				; Da, koncaj
	movlw	0xF0			; Ne
	andwf	PORTB,w			; Odstranimo spodnje 4 bite PORTB
	btfsc	STATUS,Z		; Ali je pritisnjena kaksna tipka?
	goto	Znova			; Ne, nadaljuj pregled
	iorwf	Tipka,f			; V Tipka je sedaj koordinata tipke
	return				; Koncaj branje tipkovnice	
		
;******************** PODPROGRAM ZA ZAKASNITEV 50MS **********************

Cakaj					; Podprogram za zakasnitev ~ 50ms
	movlw	.250
	movwf	Stevec2
Zacetek
	movlw	.200
	movwf	Stevec1			; Inicializiramo oba stevca
Delaj
	decfsz	Stevec1,f		; Zmanjsamo Stevec1
	goto	Delaj			; Ni se 0, nadaljuj
	decfsz	Stevec2,f		; Zmanjsamo Stevec2
	goto 	Zacetek			; Ni se 0, zacnemo od zacetka
	return				; Konec zakasnitve, izhod iz podprograma
	
	END
	
