	list		p=16f84
	#include 	<p16f84.inc>

	__CONFIG	_WDT_OFF & _PWRTE_ON & _CP_OFF & _XT_OSC

Work	equ	0x0C
Stat	equ	0x0D			; Dolocimo prostor za zacasni spremenljivki,
					; v katere bomo shranili w in STATUS

	org	0x000
	goto	Glavni			; Reset vektor, skok v glavni program

;*************************************************************************

	org	0x004

Prekinitev				; Prekinitvena rutina
	
	bcf	INTCON,GIE		; Izklopi prekinitve
	movwf	Work			; Shrani register w v Work
	swapf	STATUS,w		
	movwf	Stat			; Shrani register STATUS v Stat
	bcf	STATUS,RP0		; Banka 0
	; Ugotovimo izvor prekinitve
	btfsc	INTCON,T0IF		; Ali je izvor timer?
	goto	Timer			; Da, obdelaj prekinitev
	btfsc	INTCON,INTF		; Ali je izvor pin RB0?
	goto	Rb			; Da, obdelaj prekinitev
	btfsc	INTCON,RBIF		; Ali je izvor RB7 - RB4?
	goto	Port			; Da, obdelaj prekinitev
	goto	Konec			; Ne, zapusti rutino

Port
	; Tukaj vstavimo rutino za prekinitev RB7 - RB4
	bcf	INTCON,RBIF		; Izklopimo indikator prekinitve
	goto	Konec			; Konec rutine

Timer
	; Tukaj vstavimo rutino za timer
	bcf	INTCON,T0IF		; Izklopimo indikator prekinitve
	goto	Konec			; Konec rutine

Rb
	; Tukaj vstavimo rutino za RB0
	bcf	INTCON,INTF		; Izklopimo indikator prekinitve
	goto	Konec			; Konec rutine
	 
Konec
	swapf	Stat,w
	movwf	STATUS			; Povrnemo STATUS v prvotno stanje
	swapf	Work,f
	swapf	Work,w			; Povrnemo w v prvotno stanje
	retfie				; Izhod iz prekinitvene rutine
	
;*************************************************************************

Glavni

	; Tukaj se bodo nahajali glavni program in podprogrami
	; Na zacetku glavnega programa morate inicializirati prekinitve

	END
