	list		p=16f84
	#include 	<p16f84.inc>

	__CONFIG	_WDT_OFF & _PWRTE_ON & _CP_OFF & _XT_OSC

Stat	EQU	0x0C
Work	EQU	0x0D		; Spremenljivki, v katere shranimo registra
				; STATUS in W pri prekinitvi

	org	0x000
	goto	Glavni		; Reset vektor, skok v glavni program
	
;*************************************************************************
	org	0x004
Prek				; Prekinitvena rutina na 0x004
	bcf	INTCON,GIE	; Onemogocimo ostale prekinitve
	movwf	Work		; Shranimo register W
	swapf	STATUS,w
	movwf	Stat		; Shranimo register STATUS
	bcf	STATUS,RP0	; Banka 0
	movlw	B'00001000'
	xorwf	PORTB,f		; Preklopimo LED na RB3
	bcf	INTCON,INTF	; Izklopimo INTF
	swapf	Stat,w
	movwf	STATUS		; Obnovimo vrednost STATUS
	swapf	Work,f
	swapf	Work,w		; Obnovimo vrednost W	
	retfie			; Izhod iz prekinitvene rutine

;*************************************************************************

Glavni				; Glavni program
	bsf	STATUS,RP0	; Banka 1
	movlw	B'00000001'	
	movwf	TRISB		; RB3 izhod, RB0/INT vhod
	clrf	TRISA		; Cel PORTA izhod
	movlw	B'10000000'
	movwf	OPTION_REG	; PORTB pull-up upori izkljuceni, RBO se bo prozil 
				; s prehodom visoko/nizko
	bcf	STATUS,RP0	; Banka 0
	movlw	B'10010000'
	movwf	INTCON		; GIE=1, INTE=1, onemogocimo ostale prekinitve,
				; izbrisemo bite za sporocanje vira prekinitve
	clrf	PORTA
	clrf	PORTB		; Izklopimo vse izhode
	
Konec	goto	Konec		; Program spravimo v zanko, prekinitve delujejo v
				; ozadju

	END			; Konec
