	list		p=16f84
	#include	<p16f84.inc>


	__CONFIG	_CP_OFF & _WDT_OFF & _PWRTE_ON & _XT_OSC

Work	equ	0x0c
Stat	equ	0x0d			; Zacasni spremenljivki za W in STATUS
Frek	equ	0x0e			; Spremenljivka s frekvenco zvoka

	org	0x000
	goto	Glavni			; Pojdi na glavni program po resetu

;*************************************************************************

	org	0x004

Prekinitev				; Prekinitvena rutina
	
	bcf	INTCON,GIE		; Izklopi prekinitve
	movwf	Work			; Shrani register w
	swapf	STATUS,w		
	movwf	Stat			; Shrani register STATUS
	bcf	STATUS,RP0		; Banka 0
	movlw	B'00001000'
	xorwf	PORTB,f			; Preklopi stanje na zvocniku
	movf	Frek,w
	movwf	TMR0			; Vpisi v TMR0 frekvenco
	bcf	INTCON,T0IF		; Izbrisi T0IF
	swapf	Stat,w
	movwf	STATUS			; Povrni vrednost STATUS
	swapf	Work,f
	swapf	Work,w			; Povrni vrednost W
	retfie				; Izhod iz prekinitve
	
;*************************************************************************

Glavni					; Glavni program

	bsf	STATUS,RP0		; Banka 1
	clrf	TRISA
	clrf	TRISB			; Vsi pini izhodni
	movlw	b'10000110'
	movwf	OPTION_REG		; Preddelilnik 1:128
					; izklopi PORTB pull-up upore,
					; timer 0 povecuje strojna ura
	bcf	STATUS,RP0		; Banka 0
	clrf	PORTB			; Izklopi zvocnik
	movlw	b'10100000'
	movwf	INTCON			; GIE=1, T0IE=1. Ostale prekinitve
					; onemogocene
	movlw	.245			
	movwf	Frek			; Vpisemo frekvenco

Zanka	goto	Zanka			; Neskoncna zanka
	
	END				; Konec
